﻿Imports System.ComponentModel

Class MainWindow
    Dim ordersBL As New BindingList(Of Order)
    Dim orderItemsBL As New BindingList(Of OrderItem)
    Dim inventoryItemsBL As New BindingList(Of Inventory)
    Private Sub MainWindow_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        ordersBL.Add(New Order With {.id = 1, .d = "2011-05-05", .wc = True})
        ordersBL.Add(New Order With {.id = 2, .d = "2011-05-07", .wc = False})

        orderItemsBL.Add(New OrderItem With {.oid = 1, .qty = 4, .iid = 1000})
        orderItemsBL.Add(New OrderItem With {.oid = 1, .qty = 1, .iid = 1203})
        orderItemsBL.Add(New OrderItem With {.oid = 1, .qty = 1, .iid = 1402})
        orderItemsBL.Add(New OrderItem With {.oid = 2, .qty = 3, .iid = 1109})
        orderItemsBL.Add(New OrderItem With {.oid = 2, .qty = 1, .iid = 1000})

        inventoryItemsBL.Add(New Inventory With {.id = 1000, .name = "1.5 Hex Bolt", .descr = "1 1/2 inch Hex Bolt"})
        inventoryItemsBL.Add(New Inventory With {.id = 1109, .name = "2.0 Hex Bolt", .descr = "2 inch Hex Bolt"})
        inventoryItemsBL.Add(New Inventory With {.id = 1203, .name = "3.0 Hex Bolt", .descr = "3 inch Hex Bolt"})
        inventoryItemsBL.Add(New Inventory With {.id = 1402, .name = "4.0 Hex Bolt", .descr = "4 inch Hex Bolt"})

        AddHandler ordersBL.ListChanged, AddressOf collectionChanged
        AddHandler orderItemsBL.ListChanged, AddressOf collectionChanged
        AddHandler inventoryItemsBL.ListChanged, AddressOf collectionChanged

        Dim myOC = From o In ordersBL Join oi In orderItemsBL On o.id Equals oi.oid Join i In inventoryItemsBL On oi.iid Equals i.id Order By oi.oid

        XamDataGrid1.DataSource = myOC

    End Sub

    Private Sub collectionChanged(ByVal sender As Object, ByVal e As ListChangedEventArgs)
        'Notify the dataobject to update it's IDataErrorInfo.Errors list of errors
        sender(e.NewIndex).collectionValidation()
    End Sub

    'Private Sub test()

    '    Dim rcrd As Infragistics.Windows.DataPresenter.DataRecord = XamDataGrid1.Records(e.NewIndex)

    '    Dim objs As New ArrayList()
    '    For Each cll As Infragistics.Windows.DataPresenter.Cell In rcrd.Cells
    '        If cll.Field.GetType() = GetType(Infragistics.Windows.DataPresenter.UnboundField) Then
    '            Dim fld As Infragistics.Windows.DataPresenter.UnboundField = cll.Field
    '            If fld.BindingPath IsNot Nothing Then
    '                Dim prprtyPth As PropertyPath = fld.BindingPath
    '                Dim bndng As New Binding(prprtyPth.Path)
    '                Dim src As Object = bndng.Source
    '                Dim idei As IDataErrorInfo = src
    '                If idei IsNot Nothing Then
    '                    If Not objs.Contains(idei) Then
    '                        objs.Add(idei)
    '                    End If
    '                End If
    '            End If
    '        Else
    '            Dim fld As Infragistics.Windows.DataPresenter.Field = cll.Field
    '            Dim pth As String = fld.Name
    '            Dim bndng As New Binding(pth)
    '            Dim src As Object = bndng.Source
    '            Dim idei As IDataErrorInfo = src
    '            If idei IsNot Nothing Then
    '                If Not objs.Contains(idei) Then
    '                    objs.Add(idei)
    '                End If
    '            End If
    '        End If
    '    Next
    'End Sub

End Class
